//----------------------------------------------------------------------
//
// Apache Live Log: Monitoring multiple apache log files in realtime
//
// Version  : 0.9
// Date     : 04 February 2009
// Homepage : http://www.burlaca.com/2009/02/alivelog/
// Author   : Oleg Burlaca
//
//----------------------------------------------------------------------

// the URL of the 'alivelog.pl' script
// Note: you can rename 'alivelog.pl' to 'alivelog.cgi' 
// if *.pl files are not treated as cgi scripts
var scriptUrl = 'http://yoursite.com/cgi-bin/alivelog.pl';

// the path to the folder with country flags (with a trailing slash)
var countryFlagFolder = 'flags/';

//----------------------------------------------------------------------
var cfg = {'intervalId': '10v'};
var logData;

// 
function changeInterval() {
	cfg.intervalId = $(this).val();
	getApacheTail();
}

function changeLog() {
	cfg.logId = $(this).val();
	var logTitle = $(this).find('option:selected').text();
	document.title = logTitle + ' | ALiveLog';
	getApacheTail();
}

function getApacheTail() {
	$('#refreshBtn').attr("disabled", "true");
	
	closeVisitInfo();
	$.getJSON(scriptUrl + '?cmd=getApacheTail&logId=' + cfg.logId + '&interval=' + cfg.intervalId, processApacheTail);
}

function shortenStr (str, n) {
	if (str.length > n) { str = str.substr(0, n) + '...' }
	return str;
}

// get the AJAX response and fill the table
function processApacheTail(data) {
	logData = data;
	$('#tailTbl > tbody').empty();
	var html = '';
	var siteUrl = cfg.logs[cfg.logId].url;
	for (var i = 0; i < logData.visits.length; i++) {
		var v = logData.visits[i];
		var rf = '&nbsp;';
		if (v.refer) {
			rf = '<a onclick="window.open(this.href); return false;" href="' + v.refer + '" title="' + v.refer + '">' + shortenStr(v.refer, 55) + '</a>';
		}
		if (v.bot && v.bot != 1) {
			rf = '<b>' + v.bot + '</b>';
		}
		
		var l = v.region && v.city ? v.region + ', ' + v.city + '<br />' : '&nbsp';
		var lastPage = '&nbsp;';
		if (v.lp) {
			lastPage = '<br /><a onclick="window.open(this.href); return false;" href="' + siteUrl + v.lp + '" title="' + v.lp + '">' + shortenStr(v.lp, 55) + '</a>';
		}
		
		var tdDef = '<td class="hits">';
		if (v.bot) {
			tdDef = '<td class="hits bot">';
		} 
		if (v.err) {
			tdDef = '<td class="hits err">';
		}
		
		// html += '<tr><td><span class="' + v.cnCode.toLowerCase() +  '" title="' + v.cnName + '" /></td>' + 
		html += '<tr><td><img alt="' + v.cnName + '" title="' + v.cnName + '" src="' + countryFlagFolder + v.cnCode.toLowerCase() + '.gif" /></td>' + 
				'<td style="white-space: nowrap;">' + l + '<span>' + v.ip + '</span></td>' + 
				'<td>' + v.dt + '<br />' + v.tm + '</td>' +
				'<td><a onclick="window.open(this.href); return false;" href="' + siteUrl + v.fp + '" title="' + v.fp + '">' + shortenStr(v.fp, 55) + '</a>' + lastPage + '</td>' +
				
				'<td>' + rf + '</td>' +
				tdDef + v.t + '</td>' + 
				'<td class="cnt">' + sizeFormat(v.sz) + '</td></tr>';
	}
	
	// populate table
	$('#tailTbl > tbody').append(html);
	
	// attach event handlers
	$('#tailTbl td.hits').click(showVisitInfo);

	fillStatusBar();
	$('#refreshBtn').removeAttr('disabled'); 	
	$('#tailTbl').focus();
}

function fillStatusBar() {
	var t = 'Hits: ' + logData.totalHits + ' | Size: ' + sizeFormat(logData.totalBytes) +
			' | Time: ' + seconds2time(logData.timeInterval);
	
	t = t.replace(/\|/g, '<span class="sbDivider">|</span>');
	$('#statusBar').html(t);
}

function seconds2time (sec) {
	var t = '';
	if (sec < 60) { return sec + 'sec.' }
	if (sec < 3600) {
		var m = Math.floor(sec/60);
		return m + ' min. ' + (sec % 60) + ' sec.';
	}

	var h = Math.floor(sec/3600);
	var m = Math.floor(sec/60) % 60;
	return h + 'h ' + m + 'min. ';
}

function closeVisitInfo() {
	$('#visitInfo').hide();
	$('#main').css('bottom', 26);
}

function showVisitInfo(event) { 
	var tr = $(this).parent().get(0);
	var idx = $('#tailTblBody > tr').index(tr);
	// alert(idx + ': ' + logData.visits[idx].ip);
	
	var v = logData.visits[idx];
	var t = '<div id="infoCloseBtn"><span>Close [X]</span></div> ';
	t += '<img alt="' + v.cnName + '" title="' + v.cnName + '" src="' + countryFlagFolder + v.cnCode.toLowerCase() + '.gif" />';
	if (v.region && v.city)	{ t += ' <b>' + v.region + ', ' + v.city + '</b>' }
	t += ' <span class="gr">' + v.ip + '</span> ';
	
	t += ' <span style="padding-left: 30px; color: #333">' + v.agent + '</span>';
	
	$('#visitInfoHeader').html(t);
	
	fillVisitHits(idx);
	
	$('#main').css('bottom', 197);
	$('#visitInfo').show();
	
	$('#infoCloseBtn').click(closeVisitInfo);
	
}

function fillVisitHits(idx) {
	var v = logData.visits[idx];	
	var t = '';
	var siteUrl = cfg.logs[cfg.logId].url;
	
	for (var i = 0; i < v.hits.length; i++) {
		var h = v.hits[i];
		
		// '<td><a target="_blank" href="' + siteUrl + v.fp + '" title="' + v.fp + '">' + shortenStr(v.fp, 55) + '</a>' + lastPage + '</td>' +
		var codeTdClass = '';
		if (h.c >= 400) { codeTdClass = ' err2' }
		if (h.c >= 500) { codeTdClass = ' err'	}
		
		var rf = '';
		if (h.rf) {
			uri = h.rf;
			if (uri.indexOf(siteUrl) != -1) { uri = uri.substring(uri.indexOf(siteUrl) + siteUrl.length, uri.length) }
			rf = '<a onclick="window.open(this.href); return false;" href="' + h.rf + '">' + uri + '</a>';
		}

		t += '<tr><td class="code' + codeTdClass + '">' + h.c + '</td>' + 
			 '<td class="dt">' + h.dt + '</td><td class="tm">' + h.tm + '</td><td class="u"><a onclick="window.open(this.href); return false;" href="' + siteUrl + h.u + '">' + h.u + '</a>' +
			 '</td><td class="rf">' + rf + '</td></tr>';
	}
	$('#visitInfoTbl').html(t);
}

function refreshGrid() {
	getApacheTail();
}

function initGUI() {
	jQuery.ajaxSettings.cache = false;
	$('#interval').val('10v');
	$('#logs').val('0');
	
	$('#interval').change(changeInterval);
	$('#refreshBtn').click(refreshGrid);
	
	$(document).ajaxStart(function() {
		var x = $('#main').width()/2 - $('#ajaxBusy').width()/2;
		var t = $('#foot').position();
		var y = t.top/2;
		
		$('#main').css('background-color', '#DDD');
		$('#ajaxBusy').css('left', x).css('top',y).show();
	}).ajaxStop(function() {
		$('#ajaxBusy').hide();
		$('#main').css('background-color', '#FFF');		
	});
	
	// get Log list
	$.getJSON(scriptUrl + '?cmd=getLogs', 
	     function(data) {
			cfg.logs = data;
			var options = '';
			for (var i = 0; i < data.length; i++) {
				options += '<option value="' + i + '">' + data[i].title + '</option>';
			}
			$('#logs').html(options);
			
			$('#logs').change(changeLog);
			
			// get the last selected log from cookie
			$('#logs').val(0);
			$('#logs').trigger('change');
		});
}

function sizeFormat (bytecount) {
	var str = bytecount + '&nbsp;B';
	if (Number(bytecount) > 1024) { str = (bytecount/1000).toFixed(2)+'&nbsp;KB'; }
	if (Number(bytecount) > 1048576) { str = (bytecount/1048576).toFixed(2)+'&nbsp;MB'; }
	if (Number(bytecount) > 1073741824) { str = (bytecount/1073741824).toFixed(2)+'&nbsp;GB'; }
	return str;
};
	  
$(document).ready(function() {
   initGUI(); // do stuff when DOM is ready
});



// http://www.perlmonks.org/?node_id=258721
// http://search.cpan.org/~gbarr/TimeDate-1.16/lib/Date/Parse.pm